{$O-}
unit Unit1;

interface

uses
  TypInfo,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxInterpreter, PaxCompiler, StdCtrls, PaxBasicLanguage, PaxRunner;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    procedure PaxInterpreter1CreateObject(Sender: TPaxRunner;
      Instance: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  IMPORT_Common;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('1', 'Basic');
  PaxCompiler1.AddCodeFromFile('1', 'script.txt');
  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    PaxInterpreter1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

procedure TForm1.PaxInterpreter1CreateObject(Sender: TPaxRunner;
  Instance: TObject);
var
  pti: PTypeInfo;
  ptd: PTypeData;
begin
  if Instance is TForm then
  begin
    pti := Instance.ClassInfo;
    ptd := GetTypeData(pti);
    Sender.LoadDFMFile(Instance, ptd^.UnitName + '.dfm');
  end;
end;

end.
