unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PaxCompiler, PaxInterpreter, PaxRegister, PaxBasicLanguage,
  PaxRunner;
type
  TForm1 = class(TForm)
    PaxCompiler1: TPaxCompiler;
    Button1: TButton;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Y: Integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  H_Y: Integer;
  I: Integer;
begin
{$O-}
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);

  H_Y := PaxCompiler1.RegisterVariable(0, 'Y', _typeINTEGER, @Y);

  PaxCompiler1.AddModule('1', PaxBasicLanguage1.LanguageName);
  PaxCompiler1.AddCode('1', 'Sub P(X As Integer)');
  PaxCompiler1.AddCode('1', '  Y = Y + X');
  PaxCompiler1.AddCode('1', 'End Sub');

  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    PaxInterpreter1.RunInitialization;

    PaxInterpreter1.CallRoutine('P', [10]); // call it
    ShowMessage(IntToStr(Y));

    PaxInterpreter1.CallRoutine('P', [20]); // call it
    ShowMessage(IntToStr(Y));
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Y := 0;
end;

end.
