{$O-}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxInterpreter, PaxCompiler, StdCtrls, PaxRunner;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxPascalLanguage1: TPaxPascalLanguage;
    PaxInterpreter1: TPaxInterpreter;
    procedure Button1Click(Sender: TObject);
    procedure PaxCompiler1UnknownDirective(Sender: TPaxCompiler;
      const Directive: string; var ok: Boolean);
    procedure PaxInterpreter1CreateObject(Sender: TPaxRunner;
      Instance: TObject);
  private
    CurrModule: String;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  PAXCOMP_SYS,
  IMPORT_Common;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
  PaxCompiler1.AddModule('1', 'Pascal');
  PaxCompiler1.AddCodeFromFile('1', 'script.txt');
  if PaxCompiler1.Compile(PaxInterpreter1) then
  begin
    PaxInterpreter1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

procedure TForm1.PaxCompiler1UnknownDirective(Sender: TPaxCompiler;
  const Directive: string; var ok: Boolean);
begin
  ok := true;
  CurrModule := Sender.CurrModuleName;
end;

{$O-}
procedure TForm1.PaxInterpreter1CreateObject(Sender: TPaxRunner;
  Instance: TObject);
var
  P: PVmtMethodTable;
begin
  P := GetMethodTable(Instance.ClassType);
  if Instance is TForm then
    Sender.LoadDFMFile(Instance, CurrModule + '.dfm');
end;

end.
