////////////////////////////////////////////////////////////////////////////
// PaxCompiler
// Site: http://www.paxcompiler.com
// Author: Alexander Baranovsky (paxscript@gmail.com)
// ========================================================================
// Copyright (c) Alexander Baranovsky, 2006-2014. All rights reserved.
// Code Version: 3.2.3
// ========================================================================
// Unit: PaxCompilerRegister.pas
// ========================================================================
////////////////////////////////////////////////////////////////////////////

unit PaxCompilerRegister;

interface

uses
  Classes,
  PaxCompiler,
{$IFNDEF MACOS}
  PaxProgram,
{$ENDIF}
  PaxInterpreter,
  PaxCompilerDebugger,
  PaxCompilerExplorer,
  PaxBasicLanguage,
  PaxJavaScriptLanguage,
  PaxEval,
  PaxInvoke;

procedure Register;

Implementation

procedure Register;
begin
  RegisterComponents('PaxCompiler',
    [TPaxCompiler,
     TPaxPascalLanguage,
{$IFNDEF MACOS}
     TPaxProgram,
{$ENDIF}
     TPaxCompilerDebugger,
     TPaxCompilerExplorer,
     TPaxBasicLanguage,
     TPaxJavaScriptLanguage,
     TPaxEval,
     TPaxInvoke,
     TPaxInterpreter]);
end;

end.
